// IEListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Apparition.h"
#include "IEListDlg.h"
#include "Toolhelp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIEListDlg dialog


CIEListDlg::CIEListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CIEListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIEListDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT

}


void CIEListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIEListDlg)
	DDX_Control(pDX, IDC_BTN_REFRESH, m_btnRefresh);
	DDX_Control(pDX, IDC_BTN_DUMP_TITLE, m_btnDumpTitle);
	DDX_Control(pDX, IDC_BTN_DUMP_URL, m_btnDumpUrl);
	DDX_Control(pDX, IDC_BTN_DUMP_HTML, m_btnDumpHtml);
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIEListDlg, CDialog)
	//{{AFX_MSG_MAP(CIEListDlg)
	ON_WM_SIZE()
	ON_WM_GETMINMAXINFO()
	ON_BN_CLICKED(IDC_BTN_REFRESH, OnBtnRefresh)
	ON_BN_CLICKED(IDC_BTN_DUMP_URL, OnBtnDumpUrl)
	ON_BN_CLICKED(IDC_BTN_DUMP_HTML, OnBtnDumpHtml)
	ON_BN_CLICKED(IDC_BTN_DUMP_TITLE, OnBtnDumpTitle)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIEListDlg message handlers
#include "BrowserPhantom.h"

BOOL CIEListDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CRect rect1;
	m_btnRefresh.GetWindowRect(&rect1);

	CRect rect;
	this->GetClientRect(&rect);
	rect.bottom -= rect1.Height();
	m_list.MoveWindow(&rect);

	m_btnRefresh.MoveWindow(1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
	m_btnDumpUrl.MoveWindow(rect.Width()/4 + 1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
	m_btnDumpHtml.MoveWindow(rect.Width()/2 + 1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
	m_btnDumpTitle.MoveWindow(3*rect.Width()/4 + 1, rect.bottom, rect.Width()/4 - 2, rect1.Height());


	int count = 0;
	m_list.AddColumn(_T("HWND"), count++);
	m_list.AddColumn(_T("RECT"), count++);
	m_list.AddColumn(_T("Program Name"), count++);
	m_list.AddColumn(_T("Full Path"), count++);
	m_list.AddColumn(_T("PID"), count++);
	//m_list.AddColumn(_T("URL"), count++);
	ListView_SetExtendedListViewStyle(m_list.GetSafeHwnd(),
		LVS_EX_FULLROWSELECT /*| LVS_SHOWSELALWAYS*/);


    for(int i = 0; i < MAX_BROWSER; i++)
	{
		HWND hWnd = ::QueryBrowserHandle(i);
		if(hWnd == NULL) continue;

		CString strRect, strExeName, strExePath, strPID, strHwnd;
		strHwnd.Format(_T("0x%x"), hWnd);
        RECT rect;
		::GetWindowRect(hWnd, &rect);
		strRect.Format(_T("(%d,%d-%d,%d)"), rect.left, rect.top, rect.right, rect.bottom);


		DWORD dwPID;
	    GetWindowThreadProcessId(hWnd, &dwPID);
	    strPID.Format(_T("%d"), dwPID);

	    CToolhelp th(TH32CS_SNAPALL, dwPID);

        // Show Process details
        PROCESSENTRY32 pe = { sizeof(pe) };
        BOOL fOk = th.ProcessFirst(&pe);
        for (; fOk; fOk = th.ProcessNext(&pe))
		{
			if (pe.th32ProcessID == dwPID)
			{
			    strExeName = pe.szExeFile;			
			    break;   // No need to continue looping
			}
		}

	    MODULEENTRY32 me = { sizeof(me) };
        fOk = th.ModuleFirst(&me);
        for (; fOk; fOk = th.ModuleNext(&me)) 
		{
			CString str = me.szExePath;
		    int pos = str.ReverseFind(TCHAR('\\'));
		    if(pos != -1 && pos < str.GetLength() - 1)
			{
				str = str.Mid(pos + 1);
			    if(str.CompareNoCase(strExeName) == 0)
				{
					str = me.szExePath;
				    strExePath = str.Left(pos);
				    break;
				}
			}
		}
        int index = m_list.GetItemCount();
		m_list.AddItem(index, 0, strHwnd);
    	m_list.AddItem(index, 1, strRect);
		m_list.AddItem(index, 2, strExeName);
		m_list.AddItem(index, 3, strExePath);
		m_list.AddItem(index, 4, strPID);

		m_list.SetItemData(index, (DWORD)hWnd);
       
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIEListDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	if(m_list.GetSafeHwnd() && cx > 0 && cx < 3000)
	{
		CRect rect1;
	    m_btnRefresh.GetWindowRect(&rect1);

	    CRect rect;
	    rect.SetRect(0,0,cx,cy);
	    rect.bottom -= rect1.Height();
	    m_list.MoveWindow(&rect);

	    m_btnRefresh.MoveWindow(1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
	    m_btnDumpUrl.MoveWindow(rect.Width()/4 + 1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
	    m_btnDumpHtml.MoveWindow(rect.Width()/2 + 1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
	    m_btnDumpTitle.MoveWindow(3*rect.Width()/4 + 1, rect.bottom, rect.Width()/4 - 2, rect1.Height());
		m_list.Invalidate();
	}
}

void CIEListDlg::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) 
{
	// TODO: Add your message handler code here and/or call default
	lpMMI->ptMinTrackSize.x = 300;
	lpMMI->ptMinTrackSize.y = 200;


	CDialog::OnGetMinMaxInfo(lpMMI);
}

void CIEListDlg::OnBtnRefresh() 
{
	m_list.DeleteAllItems();
    for(int i = 0; i < MAX_BROWSER; i++)
	{
		HWND hWnd = ::QueryBrowserHandle(i);
		if(hWnd == NULL) continue;

		CString strRect, strExeName, strExePath, strPID, strHwnd;
		strHwnd.Format(_T("0x%x"), hWnd);
        RECT rect;
		::GetWindowRect(hWnd, &rect);
		strRect.Format(_T("(%d,%d-%d,%d)"), rect.left, rect.top, rect.right, rect.bottom);


		DWORD dwPID;
	    GetWindowThreadProcessId(hWnd, &dwPID);
	    strPID.Format(_T("%d"), dwPID);

	    CToolhelp th(TH32CS_SNAPALL, dwPID);

        // Show Process details
        PROCESSENTRY32 pe = { sizeof(pe) };
        BOOL fOk = th.ProcessFirst(&pe);
        for (; fOk; fOk = th.ProcessNext(&pe))
		{
			if (pe.th32ProcessID == dwPID)
			{
			    strExeName = pe.szExeFile;			
			    break;   // No need to continue looping
			}
		}

	    MODULEENTRY32 me = { sizeof(me) };
        fOk = th.ModuleFirst(&me);
        for (; fOk; fOk = th.ModuleNext(&me)) 
		{
			CString str = me.szExePath;
		    int pos = str.ReverseFind(TCHAR('\\'));
		    if(pos != -1 && pos < str.GetLength() - 1)
			{
				str = str.Mid(pos + 1);
			    if(str.CompareNoCase(strExeName) == 0)
				{
					str = me.szExePath;
				    strExePath = str.Left(pos);
				    break;
				}
			}
		}
        int index = m_list.GetItemCount();
		m_list.AddItem(index, 0, strHwnd);
    	m_list.AddItem(index, 1, strRect);
		m_list.AddItem(index, 2, strExeName);
		m_list.AddItem(index, 3, strExePath);
		m_list.AddItem(index, 4, strPID);

		m_list.SetItemData(index, (DWORD)hWnd);
       
	}
}

void CIEListDlg::OnBtnDumpUrl() 
{
    int selected = m_list.GetNextItem(-1,LVNI_SELECTED);
	if(selected == -1) return;
    
	HWND hWnd = (HWND)m_list.GetItemData(selected);
	DWORD index = ::QueryBrowserHwndIndex(hWnd);
	if(index == -1) return;
	::QueryDocument(index, WM_WPARAM_QUERY_URL);
}

void CIEListDlg::OnBtnDumpHtml() 
{
	int selected = m_list.GetNextItem(-1,LVNI_SELECTED);
	if(selected == -1) return;
    
	HWND hWnd = (HWND)m_list.GetItemData(selected);
	DWORD index = ::QueryBrowserHwndIndex(hWnd);
	if(index == -1) return;
	::QueryDocument(index, WM_WPARAM_QUERY_HTML);
}

void CIEListDlg::OnBtnDumpTitle() 
{
	int selected = m_list.GetNextItem(-1,LVNI_SELECTED);
	if(selected == -1) return;
    
	HWND hWnd = (HWND)m_list.GetItemData(selected);
	DWORD index = ::QueryBrowserHwndIndex(hWnd);
	if(index == -1) return;
	::QueryDocument(index, WM_WPARAM_QUERY_TITLE);
}
